From d2b84288687e2b6949cb93004b93b17d0ef70ff2 Mon Sep 17 00:00:00 2001
From: Adwait Nadkarni <anadkarni@ncsu.edu>
Date: Sat, 19 Oct 2013 00:21:02 -0400
Subject: [PATCH] Aquifer Security System, CCS 2013
---
 Android.mk                                         |    1 +
 api/current.txt                                    |  127 ++
 core/java/android/app/Activity.java                |  117 +-
 core/java/android/app/ActivityThread.java          |   21 +
 core/java/android/content/Intent.java              |   61 +-
 core/java/android/os/AquiferList.aidl              |    3 +
 core/java/android/os/AquiferList.java              |  196 ++
 core/java/android/os/ComponentScreen.aidl          |    3 +
 core/java/android/os/ComponentScreen.java          |   68 +
 core/java/android/os/Enforcement.aidl              |    3 +
 core/java/android/os/Enforcement.java              |   93 +
 core/java/android/os/Filter.aidl                   |    3 +
 core/java/android/os/Filter.java                   |  107 ++
 core/java/android/os/IAquiferService.aidl          |   50 +
 core/java/android/os/Participant.aidl              |    3 +
 core/java/android/os/Participant.java              |  128 ++
 core/java/android/os/Policy.aidl                   |    3 +
 core/java/android/os/Policy.java                   |  137 ++
 core/java/android/os/Process.java                  |   28 +
 services/audioflinger/Android.mk                   |    2 +-
 .../java/com/android/server/AquiferService.java    | 1979 ++++++++++++++++++++
 .../java/com/android/server/IntentResolver.java    |   94 +-
 services/java/com/android/server/SystemServer.java |   19 +-
 .../android/server/am/ActivityManagerService.java  |   98 +-
 .../java/com/android/server/am/ActivityStack.java  |  175 +-
 .../android/server/pm/PackageManagerService.java   |   81 +-
 services/jni/Android.mk                            |    3 +-
 services/jni/com_android_server_AquiferService.cpp |  271 +++
 services/jni/onload.cpp                            |    3 +-
 29 files changed, 3836 insertions(+), 41 deletions(-)
 create mode 100644 core/java/android/os/AquiferList.aidl
 create mode 100644 core/java/android/os/AquiferList.java
 create mode 100644 core/java/android/os/ComponentScreen.aidl
 create mode 100644 core/java/android/os/ComponentScreen.java
 create mode 100644 core/java/android/os/Enforcement.aidl
 create mode 100644 core/java/android/os/Enforcement.java
 create mode 100644 core/java/android/os/Filter.aidl
 create mode 100644 core/java/android/os/Filter.java
 create mode 100644 core/java/android/os/IAquiferService.aidl
 create mode 100644 core/java/android/os/Participant.aidl
 create mode 100644 core/java/android/os/Participant.java
 create mode 100644 core/java/android/os/Policy.aidl
 create mode 100644 core/java/android/os/Policy.java
 create mode 100644 services/java/com/android/server/AquiferService.java
 create mode 100644 services/jni/com_android_server_AquiferService.cpp

diff --git a/Android.mk b/Android.mk
index 371c370..89bf8e5 100644
--- a/Android.mk
+++ b/Android.mk
@@ -120,6 +120,7 @@ LOCAL_SRC_FILES += \
 	core/java/android/nfc/INfcAdapter.aidl \
 	core/java/android/nfc/INfcAdapterExtras.aidl \
 	core/java/android/nfc/INfcTag.aidl \
+	core/java/android/os/IAquiferService.aidl \
 	core/java/android/os/IHardwareService.aidl \
 	core/java/android/os/IMessenger.aidl \
 	core/java/android/os/INetworkManagementService.aidl \
diff --git a/core/java/android/app/Activity.java b/core/java/android/app/Activity.java
index 8e8d37d..2934bcb 100644
--- a/core/java/android/app/Activity.java
+++ b/core/java/android/app/Activity.java
@@ -43,10 +43,13 @@ import android.os.Build;
 import android.os.Bundle;
 import android.os.Handler;
 import android.os.IBinder;
+import android.os.Binder;
 import android.os.Looper;
 import android.os.Parcelable;
 import android.os.RemoteException;
 import android.os.StrictMode;
+import android.os.IAquiferService;
+import android.os.ServiceManager;
 import android.text.Selection;
 import android.text.SpannableStringBuilder;
 import android.text.TextUtils;
@@ -76,6 +79,7 @@ import android.view.Window;
 import android.view.WindowManager;
 import android.view.accessibility.AccessibilityEvent;
 import android.widget.AdapterView;
+import java.util.ListIterator;
 
 import java.io.FileDescriptor;
 import java.io.PrintWriter;
@@ -631,7 +635,6 @@ public class Activity extends ContextThemeWrapper
         Window.Callback, KeyEvent.Callback,
         OnCreateContextMenuListener, ComponentCallbacks2 {
     private static final String TAG = "Activity";
-
     /** Standard activity result: operation canceled. */
     public static final int RESULT_CANCELED    = 0;
     /** Standard activity result: operation succeeded. */
@@ -645,7 +648,7 @@ public class Activity extends ContextThemeWrapper
     private static final String SAVED_DIALOGS_TAG = "android:savedDialogs";
     private static final String SAVED_DIALOG_KEY_PREFIX = "android:dialog_";
     private static final String SAVED_DIALOG_ARGS_KEY_PREFIX = "android:dialog_args_";
-
+    
     private static class ManagedDialog {
         Dialog mDialog;
         Bundle mArgs;
@@ -3186,7 +3189,67 @@ public class Activity extends ContextThemeWrapper
      * @see #startActivity 
      */
     public void startActivityForResult(Intent intent, int requestCode) {
-        if (mParent == null) {
+	//Adwait's code
+	try{		
+		String processName="";
+		IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+		int pid=Binder.getCallingPid();
+		processName = aquifer.getProcessName(pid);	
+		String action=intent.getAction();
+		if(action==null)
+			action="";
+		//System.out.println("Inside StartActivityForResult:The processName is :"+processName+":"+pid);
+
+		if(action.equals(Intent.ACTION_CHOOSER))
+		{	
+			//the outer intent doesnt need these extras
+			intent.removeExtra("processName");
+			intent.removeExtra("pid");
+			intent.setProcessName(null);
+			intent.setPid(-1);
+			//System.out.println("Adwait:ACTION_CHOOSER detected.");
+			//setting the processName and pid on the inner intent, if the caller is not system or launcher
+			if(processName!=null && !processName.equals("system")&& !processName.startsWith("com.android.launcher"))
+			{
+				//System.out.println("Setting inner intent extras for ACTION_CHOOSER case.");
+				Parcelable targetParcelable = intent.getParcelableExtra(Intent.EXTRA_INTENT);
+				Intent target = (Intent)targetParcelable;
+	//			target.putExtra("processName",processName);
+        //              	target.putExtra("pid",pid);
+
+				target.setProcessName(processName);
+				target.setPid(pid);
+				
+				intent.putExtra(Intent.EXTRA_INTENT, target);
+			}
+			else
+				System.out.println("System or launcher in chooser case. Should never happen!");
+			//Get the processName and pid of the caller.
+			//add it to the intent you got from intent.EXTRA_INTENT
+			//set the processName and pid of the outer intent to null and -1, just to be safe
+			//set the ignore flag in the inner intent: not
+			//necessary: if the second time around, the caller is
+			//the system, then the pid and processnames will not be
+			//set(i have already set them the first time nyways).
+			//If they are the same app that called, then it doesnt
+			//matter if they are set again, as its the same app.
+		}
+		
+		//do only if intent action is not ACTION_CHOOSER
+		if(processName!=null && !processName.equals("system")&& !processName.startsWith("com.android.launcher") && !action.equals(Intent.ACTION_CHOOSER) && !action.equals("android.intent.action.RINGTONE_PICKER"))
+		{	
+			//System.out.println("Adding extras for process "+processName);	
+//			intent.putExtra("processName",processName);
+//			intent.putExtra("pid",pid);
+			intent.setProcessName(processName);
+			intent.setPid(pid);
+
+		}
+	}
+	catch(Exception e)
+	{System.out.println("Exception while setting processName:pid as extras");}
+	//Adwait's code ends
+	 if (mParent == null) {
             Instrumentation.ActivityResult ar =
                 mInstrumentation.execStartActivity(
                     this, mMainThread.getApplicationThread(), mToken, this,
@@ -3560,12 +3623,12 @@ public class Activity extends ContextThemeWrapper
      * @see #setResult(int)
      */
     public final void setResult(int resultCode, Intent data) {
-        synchronized (this) {
-            mResultCode = resultCode;
-            mResultData = data;
-        }
+	    synchronized (this) {
+	    	mResultCode = resultCode;
+            	mResultData = data;
+	     }
+        
     }
-
     /**
      * Return the name of the package that invoked this activity.  This is who
      * the data in {@link #setResult setResult()} will be sent to.  You can
@@ -4577,6 +4640,21 @@ public class Activity extends ContextThemeWrapper
     }
     
     final void performStop() {
+	//Adwait: Printing when an activity is stopped
+	/*
+	String processName="initial";
+	int pid=Binder.getCallingPid();
+        IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try{
+                processName=aquifer.getProcessName(pid);
+        }
+        catch(Exception e)
+        {
+                System.out.println("Exception at android.app.Activity:performStop");
+        }
+        System.out.println("Stopping activity "+processName+":"+pid);
+	*/
+	//Adwait's code ends
         if (mLoadersStarted) {
             mLoadersStarted = false;
             if (mLoaderManager != null) {
@@ -4624,6 +4702,29 @@ public class Activity extends ContextThemeWrapper
     }
 
     final void performDestroy() {
+	//Adwait: Printing when an activity is destroyed
+	String processName="initial";
+	int pid=Binder.getCallingPid();
+        IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try{
+                processName=aquifer.getProcessName(pid);
+		//System.out.println("DESTROYING ACTIVITY "+processName+":"+pid);
+		if(!processName.equals("system") && !processName.startsWith("com.android.launcher"))
+		{	
+			aquifer.destroyActivity(getComponentName().getClassName());
+		}
+        }
+        catch(Exception e)
+        {
+                System.out.println("Exception at performDestroy()");
+        }
+	/*
+	if(!processName.equals("system") && !processName.startsWith("com.android.launcher"))
+        	System.out.println("Destroying activity "+processName+":"+pid);
+	else
+		System.out.println("Aquifer cannot destroy"+processName+":"+pid);
+	*/
+	//Adwait's code ends
         mWindow.destroy();
         mFragments.dispatchDestroy();
         onDestroy();
diff --git a/core/java/android/app/ActivityThread.java b/core/java/android/app/ActivityThread.java
index 0c761fc..d5c0398 100644
--- a/core/java/android/app/ActivityThread.java
+++ b/core/java/android/app/ActivityThread.java
@@ -100,6 +100,9 @@ import java.util.regex.Pattern;
 
 import dalvik.system.CloseGuard;
 
+import android.os.Binder;
+import android.os.IAquiferService;
+
 final class SuperNotCalledException extends AndroidRuntimeException {
     public SuperNotCalledException(String msg) {
         super(msg);
@@ -3035,6 +3038,24 @@ public final class ActivityThread {
     private ActivityClientRecord performDestroyActivity(IBinder token, boolean finishing,
             int configChanges, boolean getNonConfigInstance) {
         ActivityClientRecord r = mActivities.get(token);
+	
+	
+	//Adwait's hook for destroying activities
+	/*
+	IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try{   
+                int pid = Binder.getCallingPid();
+                String processName = aquifer.getProcessName(pid);
+                System.out.println("performDestroyActivity::"+processName+":"+pid);
+		System.out.println(r.state.toString());
+                aquifer.destroyActivity(pid,processName);
+        }
+        catch(Exception e)
+        {
+                System.out.println("Exception at ActivityManagerService:activityDestroyed:"+e);
+        }
+	*/
+	//Adwait's code ends
         Class activityClass = null;
         if (localLOGV) Slog.v(TAG, "Performing finish of " + r);
         if (r != null) {
diff --git a/core/java/android/content/Intent.java b/core/java/android/content/Intent.java
index 4e5598b..db36600 100644
--- a/core/java/android/content/Intent.java
+++ b/core/java/android/content/Intent.java
@@ -3010,6 +3010,9 @@ public class Intent implements Parcelable, Cloneable {
     private Bundle mExtras;
     private Rect mSourceBounds;
     private Intent mSelector;
+    //Adwait's fields
+    private String processName;
+    private int pid;
 
     // ---------------------------------------------------------------------
 
@@ -3041,6 +3044,8 @@ public class Intent implements Parcelable, Cloneable {
         if (o.mSelector != null) {
             this.mSelector = new Intent(o.mSelector);
         }
+        this.processName = o.processName;
+        this.pid = o.pid;
     }
 
     @Override
@@ -3056,6 +3061,9 @@ public class Intent implements Parcelable, Cloneable {
         this.mComponent = o.mComponent;
         if (o.mCategories != null) {
             this.mCategories = new HashSet<String>(o.mCategories);
+        this.processName = o.processName;
+        this.pid = o.pid;
+
         }
     }
 
@@ -3571,6 +3579,27 @@ public class Intent implements Parcelable, Cloneable {
     }
 
     /**
+     * Retrieve the processName of the caller
+     * @return The sender processName of this intent or null if none specified
+     *
+     * @see #setProcessName
+     */
+    public String getProcessName() {
+        return processName;
+    }
+
+    /**
+     * Retrieve the pid of the caller
+     * TODO: Set default to -1 everywhere
+     * @return The caller's pid of this intent or 0 if none specified
+     *
+     * @see #setPid
+     */
+    public int getPid() {
+        return pid;
+    }
+
+    /**
      * Retrieve data this intent is operating on.  This URI specifies the name
      * of the data; often it uses the content: scheme, specifying data in a
      * content provider.  Other schemes may be handled by specific activities,
@@ -4419,6 +4448,32 @@ public class Intent implements Parcelable, Cloneable {
     }
 
     /**
+     * Set the caller processName.
+     *
+     * @param processName Name of the calling process
+     *
+     * @return Returns nothing
+     *
+     * @see #getProcessName
+     */
+    public void setProcessName(String processName) {
+        this.processName = processName != null ? processName : null;
+    }
+
+    /**
+     * Set the caller pid.
+     *
+     * @param pid pid of the calling process
+     *
+     * @return Returns nothing
+     *
+     * @see #getPid
+     */
+    public void setPid(int pid) {
+        this.pid = pid;
+    }
+
+    /**
      * Set the data this intent is operating on.  This method automatically
      * clears any type that was previously set by {@link #setType}.
      *
@@ -6084,7 +6139,8 @@ public class Intent implements Parcelable, Cloneable {
         out.writeInt(mFlags);
         out.writeString(mPackage);
         ComponentName.writeToParcel(mComponent, out);
-
+	out.writeString(processName);
+	out.writeInt(pid);
         if (mSourceBounds != null) {
             out.writeInt(1);
             mSourceBounds.writeToParcel(out, flags);
@@ -6133,7 +6189,8 @@ public class Intent implements Parcelable, Cloneable {
         mFlags = in.readInt();
         mPackage = in.readString();
         mComponent = ComponentName.readFromParcel(in);
-
+	processName=in.readString();
+	pid=in.readInt();
         if (in.readInt() != 0) {
             mSourceBounds = Rect.CREATOR.createFromParcel(in);
         }
diff --git a/core/java/android/os/AquiferList.aidl b/core/java/android/os/AquiferList.aidl
new file mode 100644
index 0000000..5f5b2eb
--- /dev/null
+++ b/core/java/android/os/AquiferList.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable AquiferList;
diff --git a/core/java/android/os/AquiferList.java b/core/java/android/os/AquiferList.java
new file mode 100644
index 0000000..1ac1313
--- /dev/null
+++ b/core/java/android/os/AquiferList.java
@@ -0,0 +1,196 @@
+/* Abstraction for the ArrayList<String> Class.
+ * Defines set functions: union, intersection, difference for lists.
+ * Author: Adwait Nadkarni
+ */
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import java.util.ArrayList;
+import java.util.ListIterator;
+import java.io.Serializable;
+//to be used as both lists and pos and neg capabilities
+//since we have separated the pos and neg capabilities into 2 lists
+//this becomes easy.
+public class AquiferList implements Parcelable
+{	
+	private ArrayList<String> list;
+	public static String EMPTY = "EMPTY";
+	public static final Parcelable.Creator<AquiferList> CREATOR = new
+        Parcelable.Creator<AquiferList>() {
+                public AquiferList createFromParcel(Parcel in) {
+                         return new AquiferList(in);
+                }
+                 public AquiferList[] newArray(int size) {
+                        return new AquiferList[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private AquiferList(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+                out.writeStringList(list);
+        }
+
+        public void readFromParcel(Parcel in) {
+               	 list = new ArrayList<String>();
+		 in.readStringList((ArrayList<String>)list);
+        }
+	
+	public AquiferList()
+	{
+		//initialize a full list by default
+		list = new ArrayList<String>();
+	}
+	public AquiferList(ArrayList<String> list2)
+	{
+		this.list = list2;
+	}
+	public ArrayList<String> getList()
+	{
+		return this.list;
+	}
+	public void setList(ArrayList<String> list2)
+	{
+		this.list = list2;
+	}
+	public boolean add(String t)
+	{	
+		if(t.equals(EMPTY))
+			return false;
+		boolean empty=this.isEMPTY();
+		boolean b = list.add(t);
+		//check if the list was EMPTY before this successful addition,
+		//and remove the empty flag if it is
+		if(b && empty)
+			list.remove(EMPTY);
+		return b;
+	} 
+	public boolean remove(String t)
+	{
+		boolean b =list.remove(t);
+		//if this was the last element, then set the list as EMPTY
+		if(list.isEmpty())
+			list.add(EMPTY);
+		return b;
+		
+	}
+	public boolean contains(String t)
+	{
+		return list.contains(t);
+	}
+	public void includeAll()
+	{
+		list.clear();
+	}
+	public void setEmpty()
+	{
+		list.clear();
+		list.add(EMPTY);
+	}
+	public String getAtIndex(int index)
+	{
+		return (String)(list.get(index));	
+	}
+	public boolean isEmpty()
+	{
+		return list.isEmpty();
+	}
+	public boolean isEMPTY()
+	{
+  		if((list.size()==1) &&  (list.contains(EMPTY)))
+			return true;
+		return false;	
+	}
+	public int size()
+	{
+		//Minimum list size is 1. Numerical intarray contains -1 if list is EMPTY
+		return list.size();
+	}
+	public void displayAquiferList()
+	{	
+		ListIterator<String> li1 = list.listIterator();
+                while(li1.hasNext())
+                {       String t1 = li1.next();
+			System.out.println("|"+t1+"|");
+                }	
+	}	
+
+	//Set functions:
+	//For list1 union list2
+        public static AquiferList listUnion(AquiferList list1, AquiferList list2)
+        {	
+		//checking for conditions when the list is either FULL(isEmpty) or EMPTY(isEMPTY) 
+		if(list1.isEmpty())
+			return list1;
+		else if(list2.isEmpty())
+			return list2;
+		else if(list1.isEMPTY())
+			return list2;
+		else if(list2.isEMPTY())
+			return list1;
+		else{}
+
+                AquiferList list3 = new AquiferList();
+                //Adding all of list1's elements to list3
+                ListIterator<String> li1 = list1.getList().listIterator();
+                while(li1.hasNext())
+                {
+                        list3.add(li1.next());
+                }
+
+                //iterating through list 2, and adding all the elements in 
+                //list 2 to list 3, except for all the elements that are already
+                //present in list3
+                ListIterator<String> li2 = list2.getList().listIterator();
+                while(li2.hasNext())
+                {
+                        String t =li2.next();
+                        boolean add = true;
+                        if(list3.contains(t))
+                        {
+                        	add = false;
+                        }
+                        if(add)
+                        {
+                                list3.add(t);
+                        }
+                }
+
+                return list3;
+        }
+
+        //for list1 INTERSECTION list2
+        public static AquiferList listIntersection(AquiferList list1, AquiferList list2)
+        {
+		//checking for conditions when the list is either FULL(isEmpty) or EMPTY(isEMPTY) 
+                if(list1.isEmpty())
+                        return list2;
+                else if(list2.isEmpty())
+                        return list1;
+                else if(list1.isEMPTY())
+                        return list1;
+		else if(list2.isEMPTY())
+			return list2;
+                else{}
+                
+                AquiferList list3 = new AquiferList();
+		//traversing list 1
+                //for each element in list 1, traversing list 2
+                //if a match is found in list2, adding it to list 3
+                //otherwise continue traversing list 1
+                ListIterator<String> li1 = list1.getList().listIterator();
+                while(li1.hasNext())
+                {       String t1 = li1.next();
+                        if(list2.contains(t1))
+                        {
+                        	list3.add(t1);
+                        }
+                }
+                return list3;
+        }
+}	
diff --git a/core/java/android/os/ComponentScreen.aidl b/core/java/android/os/ComponentScreen.aidl
new file mode 100644
index 0000000..ff8228f
--- /dev/null
+++ b/core/java/android/os/ComponentScreen.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable ComponentScreen;
diff --git a/core/java/android/os/ComponentScreen.java b/core/java/android/os/ComponentScreen.java
new file mode 100644
index 0000000..59a6d85
--- /dev/null
+++ b/core/java/android/os/ComponentScreen.java
@@ -0,0 +1,68 @@
+/* Abstraction for the ArrayList<String> Class.
+ * Defines set functions: union, intersection, difference for lists.
+ * Author: Adwait Nadkarni
+ */
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import java.util.ArrayList;
+import java.util.ListIterator;
+import java.io.Serializable;
+//to be used as both lists and pos and neg capabilities
+//since we have separated the pos and neg capabilities into 2 lists
+//this becomes easy.
+public class ComponentScreen implements Parcelable
+{	
+	String componentName;
+	int resultcode;
+	long timestamp;
+	public static final Parcelable.Creator<ComponentScreen> CREATOR = new
+        Parcelable.Creator<ComponentScreen>() {
+                public ComponentScreen createFromParcel(Parcel in) {
+                         return new ComponentScreen(in);
+                }
+                 public ComponentScreen[] newArray(int size) {
+                        return new ComponentScreen[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private ComponentScreen(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+                out.writeString(componentName);
+		out.writeInt(resultcode);
+		out.writeLong(timestamp);
+        }
+
+        public void readFromParcel(Parcel in) {
+		 
+		 this.componentName = in.readString();
+		 this.resultcode = in.readInt();
+		 this.timestamp = in.readLong();
+        }
+	
+	public ComponentScreen(String cname, int rcode, long tstamp)
+	{
+		componentName = cname;
+		resultcode = rcode;
+		timestamp = tstamp;
+	}
+	
+	public String getComponentName()
+	{
+		return this.componentName;	
+	}
+	public int getResultCode()
+	{
+		return this.resultcode;
+	}
+	public long getTimeStamp()
+	{
+		return this.timestamp;
+	}
+}	
diff --git a/core/java/android/os/Enforcement.aidl b/core/java/android/os/Enforcement.aidl
new file mode 100644
index 0000000..85951b2
--- /dev/null
+++ b/core/java/android/os/Enforcement.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable Enforcement;
diff --git a/core/java/android/os/Enforcement.java b/core/java/android/os/Enforcement.java
new file mode 100644
index 0000000..404e118
--- /dev/null
+++ b/core/java/android/os/Enforcement.java
@@ -0,0 +1,93 @@
+/* Enforcement Class.
+ * Defines Enforcement{AllowedList, RequiredList}
+ * Author: Adwait Nadkarni
+ */
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import android.os.AquiferList;
+import java.util.ListIterator;
+public class Enforcement implements Parcelable
+{	
+	private AquiferList AllowedList;
+	private AquiferList RequiredList;
+	public static final Parcelable.Creator<Enforcement> CREATOR = new
+        Parcelable.Creator<Enforcement>() {
+                public Enforcement createFromParcel(Parcel in) {
+                         return new Enforcement(in);
+                }
+                 public Enforcement[] newArray(int size) {
+                        return new Enforcement[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private Enforcement(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+                out.writeParcelable(AllowedList,flags);
+                out.writeParcelable(RequiredList,flags);
+        }
+
+        public void readFromParcel(Parcel in) {
+               	 AllowedList = in.readParcelable(AquiferList.class.getClassLoader());
+               	 RequiredList = in.readParcelable(AquiferList.class.getClassLoader());
+        }
+	
+	//Constructors
+	public Enforcement()
+	{
+		//The allowedList is full by default
+		AllowedList = new AquiferList();
+		//The requiredList is empty by default
+		RequiredList = new AquiferList();
+		RequiredList.setEmpty();
+	}
+	public Enforcement(Enforcement e)
+	{
+		this.AllowedList = e.AllowedList;
+		this.RequiredList = e.RequiredList;
+	}
+
+	//Getters and Setters
+	public AquiferList getAllowedList()
+	{
+		return this.AllowedList;
+	}
+	public void setAllowedList(AquiferList allowed)
+	{
+		this.AllowedList = allowed;
+	}
+	public AquiferList getRequiredList()
+	{
+		return this.RequiredList;
+	}
+	public void setRequiredList(AquiferList required)
+	{
+		this.RequiredList = required;
+	}
+
+	//Enforcement Display method
+	public void displayEnforcement()
+	{	
+		System.out.println("Enforcement Lists:");
+		System.out.println("Allowed List:");
+		AllowedList.displayAquiferList();
+		System.out.println("Required List:");
+		RequiredList.displayAquiferList();
+	}	
+	
+	//Enforcement Join function
+	public static Enforcement enforcementJoin(Enforcement enforce1, Enforcement enforce2)
+	{
+		Enforcement enforce3 = new Enforcement();
+		enforce3.AllowedList = AquiferList.listIntersection(enforce1.getAllowedList(), enforce2.getAllowedList());
+		enforce3.RequiredList = AquiferList.listUnion(enforce1.getRequiredList(), enforce2.getRequiredList());
+		return enforce3;
+	}
+
+}	
diff --git a/core/java/android/os/Filter.aidl b/core/java/android/os/Filter.aidl
new file mode 100644
index 0000000..7b76ab5
--- /dev/null
+++ b/core/java/android/os/Filter.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable Filter;
diff --git a/core/java/android/os/Filter.java b/core/java/android/os/Filter.java
new file mode 100644
index 0000000..1d82961
--- /dev/null
+++ b/core/java/android/os/Filter.java
@@ -0,0 +1,107 @@
+/* Filter Class.
+ * Defines Filter{<Action, PrincialList>}
+ * Author: Adwait Nadkarni
+ */
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import android.os.AquiferList;
+import java.util.ListIterator;
+import java.util.HashMap;
+import java.io.Serializable;
+public class Filter implements Parcelable
+{	
+	private HashMap<String, AquiferList> FilterMap;
+	public static final Parcelable.Creator<Filter> CREATOR = new
+        Parcelable.Creator<Filter>() {
+                public Filter createFromParcel(Parcel in) {
+                         return new Filter(in);
+                }
+                 public Filter[] newArray(int size) {
+                        return new Filter[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private Filter(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+                out.writeMap(FilterMap);
+        }
+
+        public void readFromParcel(Parcel in) {
+		FilterMap = new HashMap<String, AquiferList>();
+               	in.readMap(FilterMap,AquiferList.class.getClassLoader());
+        }
+
+	//Constructors	
+	public Filter()
+	{
+		FilterMap = new HashMap<String, AquiferList>();
+	}
+	public Filter(Filter filter)
+	{
+		this.FilterMap = filter.FilterMap;
+	}
+
+	//Getters and Setters
+	public AquiferList getPrincipals(String action)
+	{
+		return this.FilterMap.get(action);
+	}
+	public void setPrincipals(String action, AquiferList Principals)
+	{
+		this.FilterMap.put(action, Principals);
+		//Principals.displayAquiferList();
+	}
+
+	public HashMap<String, AquiferList> getFilterMap()
+	{
+		return this.FilterMap;
+	}
+	public void setFilterMap(HashMap<String, AquiferList> FilterMap)
+	{
+		this.FilterMap = FilterMap;
+	}
+	public boolean containsAction(String action)
+	{
+		return this.FilterMap.containsKey(action);
+	}
+	//Display Method
+	public void displayFilter()
+	{	
+		System.out.println("Printing Filter:");
+		for ( String action : this.FilterMap.keySet())
+		{	
+			System.out.println("For Action:"+action);
+			(FilterMap.get(action)).displayAquiferList();	
+		}
+	}	
+
+	//Filter Join function
+	public static Filter filterJoin(Filter filter1, Filter filter2)
+	{
+		Filter filter3 = new Filter();
+
+		//copying filter1 to filter3
+		for ( String action : filter1.FilterMap.keySet())
+		{	
+			filter3.setPrincipals(action, filter1.FilterMap.get(action));
+		}
+		
+		//For common actions, take the intersection of the Principals
+		for ( String action : filter2.FilterMap.keySet())
+		{
+			if(filter3.containsAction(action))
+				filter3.setPrincipals(action, AquiferList.listIntersection(filter1.getPrincipals(action), filter2.getPrincipals(action)));		
+			else
+				filter3.setPrincipals(action, filter2.FilterMap.get(action));
+		}
+		return filter3;
+	}
+
+}	
